local mod = ...



-- Building Function: Gather Berries -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_COTTAGE_BERRIES",
    Name = "BUILDING_FUNCTION_COTTAGE_BERRIES_NAME",
    WorkerCapacity = 2,
    RelatedJob = { 
        Job = "GATHERER", 
        Behavior = "BEHAVIOR_GATHER"
    },
    InputInventoryCapacity = {
	},
    ResourceListNeeded = {
		{ Resource = "BERRIES", Quantity = 1 },
	},
    ResourceProduced = {
		{ Resource = "BERRIES", Quantity = 1 },
	}
})



-- Building Function: Gather Wood -------------------------------------------------------------------------------------
local behaviorWoodcutter = "BEHAVIOR_GATHER"
if (foundation.isModLoaded("59f226a2-a363-4804-bf91-668dec627b70")) then -- stumps
    behaviorWoodcutter = "BEHAVIOR_WOODCUTTER_STUMP"
else

end

mod:registerAsset({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_COTTAGE_WOOD",
    Name = "BUILDING_FUNCTION_COTTAGE_WOOD_NAME",
    WorkerCapacity = 2,
    RelatedJob = { 
        Job = "WOOD_CUTTER",
        Behavior = behaviorWoodcutter,
    },
    InputInventoryCapacity = {
	},
    ResourceListNeeded = {
		{ Resource = "WOOD", Quantity = 1 },
	},
    ResourceProduced = {
		{ Resource = "WOOD", Quantity = 1 },
	}
})



if (foundation.isModLoaded("c8b63172-5b6d-45eb-9fab-a40c8ecd9947")) then -- vegetable farms

    -- Building Function: Grow Beans -------------------------------------------------------------------------------------
    mod:registerAsset({
        DataType = "BUILDING_FUNCTION_FARM",
        Id = "BUILDING_FUNCTION_COTTAGE_BEAN",
        Name = "BUILDING_FUNCTION_COTTAGE_BEAN_NAME",
        WorkerCapacity = 2,
        RelatedJob = { 
            Job = "JOB_VEGETABLEFARM_FARM", 
            Behavior = "BEHAVIOR_FARMER"
        },
        ResourceListNeeded = {
            { Resource = "RESOURCE_VEGETABLE", Quantity = 1 }, 
        },
        ResourceProduced = {
            { Resource = "RESOURCE_VEGETABLE", Quantity = 1 },
        },

        SowingDurationPerc = {0, 6},
        GrowDuration = {6, 10},
        GrowWaitDuration = {10, 12},
        HarvestDuration = {12, 18},
        RestDuration = {18, 21},

        QuantityToHarvestPerStep = 1,
        HarvestStepsCount = 10,
        QuantityToPlantPerStep = 1,
        PlantingStepsCount = 1,
        ResourceValuePerGather = 0.15,
        
        CropFieldConfig = "FARM_FIELD_CONFIG_VEGETABLEFARM_BEAN",
        GrowingSetup = "INTERACTIVE_LOCATION_SETUP_VEGETABLEFARM_GROWING",
        SowingSetup = "INTERACTIVE_LOCATION_SETUP_VEGETABLEFARM_SOWING",
        HarvestSetup = "INTERACTIVE_LOCATION_SETUP_VEGETABLEFARM_HARVEST"
    })



    -- Building Function: Grow Cabbages -------------------------------------------------------------------------------------
    mod:registerAsset({
        DataType = "BUILDING_FUNCTION_FARM",
        Id = "BUILDING_FUNCTION_COTTAGE_CABBAGE",
        Name = "BUILDING_FUNCTION_COTTAGE_CABBAGE_NAME",
        WorkerCapacity = 2,
        RelatedJob = { 
            Job = "JOB_VEGETABLEFARM_FARM", 
            Behavior = "BEHAVIOR_FARMER"
        },
        ResourceListNeeded = {
            { Resource = "RESOURCE_VEGETABLE", Quantity = 1 }, 
        },
        ResourceProduced = {
            { Resource = "RESOURCE_VEGETABLE", Quantity = 1 },
        },

        SowingDurationPerc = {0, 6},
        GrowDuration = {6, 10},
        GrowWaitDuration = {10, 12},
        HarvestDuration = {12, 18},
        RestDuration = {18, 21},

        QuantityToHarvestPerStep = 1,
        HarvestStepsCount = 10,
        QuantityToPlantPerStep = 1,
        PlantingStepsCount = 1,
        ResourceValuePerGather = 0.15,
        
        CropFieldConfig = "FARM_FIELD_CONFIG_VEGETABLEFARM_CABBAGE",
        GrowingSetup = "INTERACTIVE_LOCATION_SETUP_VEGETABLEFARM_GROWING",
        SowingSetup = "INTERACTIVE_LOCATION_SETUP_VEGETABLEFARM_SOWING",
        HarvestSetup = "INTERACTIVE_LOCATION_SETUP_VEGETABLEFARM_HARVEST"
    })

end



-- Building Function: Bake Bread -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_COTTAGE_BREAD",
    Name = "BUILDING_FUNCTION_COTTAGE_BREAD_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "BAKER", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "FLOUR", Quantity = 10 },
		{ Resource = "WATER", Quantity = 10 },
	},
    ResourceListNeeded = {
		{ Resource = "FLOUR", Quantity = 2 },
		{ Resource = "WATER", Quantity = 2 },
	},
    ResourceProduced = {
		{ Resource = "BREAD", Quantity = 1 }
	}
})



-- Building Function: Make Cheese -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_COTTAGE_CHEESE",
    Name = "BUILDING_FUNCTION_COTTAGE_CHEESE_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "CHEESE_MAKER", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "MILK", Quantity = 10 },
	},
    ResourceListNeeded = {
		{ Resource = "MILK", Quantity = 2 },
	},
    ResourceProduced = {
		{ Resource = "CHEESE", Quantity = 1 },
	}
})



-- Building Function: Weave Cloth -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_COTTAGE_CLOTH",
    Name = "BUILDING_FUNCTION_COTTAGE_CLOTH_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "WEAVER", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "WOOL", Quantity = 10 },
	},
    ResourceListNeeded = {
		{ Resource = "WOOL", Quantity = 2 },
	},
    ResourceProduced = {
		{ Resource = "WOOLEN_CLOTH", Quantity = 1 },
	}
})



-- Building Function: Sew Clothes -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_COTTAGE_CLOTHES",
    Name = "BUILDING_FUNCTION_COTTAGE_CLOTHES_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "TAILOR", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "WOOLEN_CLOTH", Quantity = 10 },
	},
    ResourceListNeeded = {
		{ Resource = "WOOLEN_CLOTH", Quantity = 2 },
	},
    ResourceProduced = {
		{ Resource = "CLOTHES", Quantity = 1 },
	}
})



-- Building Function: Make Furniture -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_COTTAGE_FURNITURE",
    Name = "BUILDING_FUNCTION_COTTAGE_FURNITURE_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOINER_JOB", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "PLANK", Quantity = 10 },
		{ Resource = "WOOLEN_CLOTH", Quantity = 10 },
	},
    ResourceListNeeded = {
		{ Resource = "PLANK", Quantity = 1 },
		{ Resource = "WOOLEN_CLOTH", Quantity = 1 }
	},
    ResourceProduced = {
		{ Resource = "RESOURCE_FURNITURE", Quantity = 1 }
	}
})



-- Building Function: Grow Apples -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_FUNCTION_FARM",
    Id = "BUILDING_FUNCTION_COTTAGE_FRUIT",
    Name = "BUILDING_FUNCTION_COTTAGE_FRUIT_NAME",
    WorkerCapacity = 2,
    RelatedJob = { 
        Job = "JOB_ORCHARD", 
        Behavior = "BEHAVIOR_FARMER"
    },
    -- InputInventoryCapacity = {
		-- { Resource = "WATER", Quantity = 5 },
		-- { Resource = "RESOURCE_DUNG", Quantity = 5 }
	-- },
    ResourceListNeeded = {
		{ Resource = "RESOURCE_FRUIT", Quantity = 1 }, 
	},
	ResourceProduced = {
        { Resource = "RESOURCE_FRUIT", Quantity = 1 },
    },

    -- there is a max total cycle of 21 days so if you plan beyond that, it will be cut short
    SowingDurationPerc = {0, 1}, 
	GrowDuration = {1, 2}, 
	GrowWaitDuration = {2, 6},
	HarvestDuration = {6, 18},
	RestDuration = {18, 21},

    QuantityToHarvestPerStep = 1,
	HarvestStepsCount = 1,
	ResourceValuePerGather = 1,

    QuantityToPlantPerStep = 0,
	PlantingStepsCount = 0,

    CropFieldConfig = "FARM_FIELD_CONFIG_ORCHARD_FARM_APPLE",
    GrowingSetup = "INTERACTIVE_LOCATION_SETUP_ORCHARD_FARM_GROWING", 
    SowingSetup = "INTERACTIVE_LOCATION_SETUP_ORCHARD_FARM_SOWING", 
    HarvestSetup = "INTERACTIVE_LOCATION_SETUP_ORCHARD_FARM_HARVEST"
})



-- Building Function: Cottage Industry ASSIGNABLE -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_FUNCTION_ASSIGNABLE",
    Id = "BUILDING_FUNCTION_ASSIGNABLE_COTTAGE",
    AuthorizedFunctionList = "FUNCTION_LIST_COTTAGE"
})

mod:registerAsset({
    DataType = "BUILDING_FUNCTION_LIST",
    Id = "FUNCTION_LIST_COTTAGE",
    AssetFunctionList = {
        "BUILDING_FUNCTION_COTTAGE_BERRIES",
        "BUILDING_FUNCTION_COTTAGE_WOOD",
        "BUILDING_FUNCTION_FORESTER",
        "BUILDING_FUNCTION_COTTAGE_FRUIT",
        "BUILDING_FUNCTION_COTTAGE_BREAD",
        "BUILDING_FUNCTION_COTTAGE_CHEESE",
        "BUILDING_FUNCTION_COTTAGE_CLOTH",
        "BUILDING_FUNCTION_COTTAGE_CLOTHES",
        "BUILDING_FUNCTION_COTTAGE_FURNITURE",
        "BUILDING_FUNCTION_HUNTERS_HUT",
    }
})



if (foundation.isModLoaded("c8b63172-5b6d-45eb-9fab-a40c8ecd9947")) then -- vegetable farms
    mod:overrideAsset({
        Id = "FUNCTION_LIST_COTTAGE",
        AssetFunctionList = {
            Action = "APPEND",
            "BUILDING_FUNCTION_COTTAGE_BEAN",
            "BUILDING_FUNCTION_COTTAGE_CABBAGE",
        }
    })
end



-- Give names to unnamed functions
mod:overrideAsset({
    Id = "BUILDING_FUNCTION_FORESTER",
    Name = "BUILDING_FUNCTION_FORESTER_NAME"
})

mod:overrideAsset({
    Id = "BUILDING_FUNCTION_HUNTERS_HUT",
    Name = "BUILDING_FUNCTION_HUNTERS_HUT_NAME"
})



-- Allow large serf houses to have a workplace function -------------------------------------------------------------------------------------
mod:overrideAsset({
    Id = "BUILDING_PART_HOUSING_SERF_DENSITY_2",
    Name = "BUILDING_PART_HOUSING_SERF_DENSITY_2_NAME",
    AssetBuildingFunction = "BUILDING_FUNCTION_ASSIGNABLE_COTTAGE"
})

